#pragma once
#include"tmg_type_adv.h"
#include"tmg_sdk.h"

class ITMGAudioRecordCtrl {
public:
	virtual ~ITMGAudioRecordCtrl(){};

	virtual int StartRecord(AUDIO_RECORDING_TYPE type, const char* dstFile, const char* accMixFile, const char* accPlayFile) = 0;
	virtual int StopRecord() = 0;
	virtual int PauseRecord() = 0;
	virtual int ResumeRecord() = 0;
	virtual int SetAccompanyFile(const char* accPlayFile) = 0;
	virtual int GetAccompanyTotalTimeByMs() = 0;
	virtual int SetRecordTimeByMs(int timePlay, int timeRecord) = 0;
	virtual int GetRecordTimeByMs() = 0;
	virtual int SetRecordKaraokeType(int type) = 0;
	virtual int GetRecordFileDurationByMs() = 0;

	virtual int StartPreview() = 0;
	virtual int StopPreview() = 0;
	virtual int PausePreview() = 0;
	virtual int ResumePreview() = 0;
	virtual int SetPreviewTimeByMs(int time) = 0;
	virtual int GetPreviewTimeByMs() = 0;
	virtual int SetMixWieghts(float mic, float acc) = 0;
	virtual int AdjustAudioTimeByMs(int time) = 0;
	virtual int MixRecordFile() = 0;
	virtual int CancelMixRecordFile() = 0;
	virtual int CleanTask() = 0;
};

QAVSDK_API ITMGAudioRecordCtrl* QAVSDK_CALL ITMGAudioRecordCtrlGetInstance();
